package 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.display3D.Context3D;
	import flash.display3D.Context3DRenderMode;
	import flash.events.Event;
	import flash.text.TextField;
	import jp.live2d.*;
	
	/**
	 * 
	 */
${SWF}
	public class Main extends Sprite
	{
${EMBED}

		public var model:LAppModel;
		public var context3D:Context3D;
		
		public function Main() 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			Live2D.init();
			var tf:TextField = new TextField;
			tf.text = "Live2D "+Live2D.__L2D_VERSION_STR__;
			addChild(tf);
			
			
			//3Dレイヤーの準備
			stage.stage3Ds[0].addEventListener(Event.CONTEXT3D_CREATE, onCreateStage3D,false,1);
			stage.stage3Ds[0].requestContext3D(Context3DRenderMode.AUTO);
		}
		
		
		public function onCreateStage3D(e:Event):void 
		{
			context3D = stage.stage3Ds[0].context3D;
			
			context3D.configureBackBuffer(stage.stageWidth, stage.stageHeight, 0, false);
			context3D.setRenderToBackBuffer();
			context3D.enableErrorChecking = true;//エラーチェック

			model = new LAppModel();
			model.load(stage);
			
			addEventListener(Event.ENTER_FRAME, update);
		}
		
		
		public function update(e:Event):void 
		{
			context3D.clear(1, 1, 1, 1);
			
			model.update();
			model.draw();
			
			context3D.present();
		}
	}

}